﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Net;
using System.Text;
using System.Text.RegularExpressions;
using System.Threading;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;


public partial class StreamInlineAsyncDelegatePage : System.Web.UI.Page
{
    public delegate void ProcessRequestDelegate(HttpContext context);
    private AsyncRequest request;

    protected void Page_Load(object sender, EventArgs e)
    {

        //AddOnPreRenderCompleteAsync(
        //    new BeginEventHandler(BeginAsyncOperation),
        //    new EndEventHandler(EndAsyncOperation)
        //);

        PageAsyncTask task = new PageAsyncTask(
            new BeginEventHandler(BeginAsyncOperation),
            new EndEventHandler(EndAsyncOperation),
            new EndEventHandler(TimeoutAsyncOperation),
            null
        );
        RegisterAsyncTask(task);
    }
    
    IAsyncResult BeginAsyncOperation(object sender, EventArgs e,
        AsyncCallback cb, object state)
    {
        ProcessRequestDelegate prg = new ProcessRequestDelegate(Process);
        return prg.BeginInvoke(HttpContext.Current, cb, state);
    }

    void EndAsyncOperation(IAsyncResult ar)
    {
        Response.End();
    }

    void TimeoutAsyncOperation(IAsyncResult ar)
    {
        string text = "Data temporarily unavailable";
        Response.Write(text);
        Response.Flush();
    }

    public void Process(HttpContext context)
    {
        context.Response.ContentType = "text/html";
        context.Response.BufferOutput = true;
        //Send 256 dummy bytes.
        string dummy = "                                                                                                                                                                                                                                                                ";
        context.Response.Write(dummy + "<strong><u>Fictitious report !</u></strong> <br>");
        for (int i = 1; i <= 15; i++)
        {
            if (context.Response.IsClientConnected)
            {
                context.Response.Write(string.Format("Report part{0}.<br>", i));
                if (i == 15)
                    context.Response.Write("Report complete.");
                context.Response.Flush();
                Trace.Write("flush");
                Trace.Write(System.AppDomain.GetCurrentThreadId().ToString());
                Thread.Sleep(1000);
            }
        }
    }
    
}
