﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Net;
using System.Text;
using System.Text.RegularExpressions;
using System.Threading;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;


public partial class StreamInlineAsyncPage : System.Web.UI.Page
{
    private AsyncRequest request;

    protected void Page_Load(object sender, EventArgs e)
    {
        //AddOnPreRenderCompleteAsync(
        //    new BeginEventHandler(BeginAsyncOperation),
        //    new EndEventHandler(EndAsyncOperation)
        //);
        PageAsyncTask task = new PageAsyncTask(
            new BeginEventHandler(BeginAsyncOperation),
            new EndEventHandler(EndAsyncOperation),
            new EndEventHandler(TimeoutAsyncOperation),
            null
        );
        RegisterAsyncTask(task);
    }

    IAsyncResult BeginAsyncOperation(object sender, EventArgs e,
        AsyncCallback cb, object state)
    {
        request = new AsyncRequest();
        return request.BeginProcessRequest(HttpContext.Current, cb, state);
    }

    void EndAsyncOperation(IAsyncResult ar)
    {
        Response.End();
    }

    void TimeoutAsyncOperation(IAsyncResult ar)
    {
        string text = "Data temporarily unavailable";
        Response.Write(text);
        Response.Flush();
    }
}
